
/*------------------------------------------------------------------------
    File        : 01_builder/start.p
    Purpose     : starting the Builder Pattern example
    Author(s)   : Xara Arnold, IAP GmbH
    
  ----------------------------------------------------------------------*/

USING 01_builder.User.
USING 01_builder.UserBuilder.

/*---------------------------------Definitions----------------------------------*/

DEFINE VARIABLE oUser AS User NO-UNDO.

/*---------------------------------Main Block-----------------------------------*/

/* The builder call may look in the first moment somehat irritating to OE programmers.
   The first part (NEW) creates the builder object. The constructor returns the builder.
   The second part (setAge) calls a method in the builder. Again returns the builder.
   This will happen multiple times.
   The last call (build) will create and then return the user. 
 */
oUser = (NEW UserBuilder("Una", "Person")
        :setAge(23)
        :setPhone("+49 40-30 68 03-26")
        :setAddress("Valentinskamp 30, 20355 Hamburg")
        :build()).

MESSAGE "Used UserBuilder to build a User." SKIP
        oUser:cFirstName oUser:cLastName 
        "of age" oUser:iAge SKIP
        oUser:cPhone SKIP
        oUser:cAddress
  VIEW-AS ALERT-BOX.
