 /*---------------------------------------------------------------------
    File        : invoice.cls
    Author(s)   : xara.arnold, Klaus Erichsen

  Lazy loading demostration. When the proporty iInvoiceSum is accessed
  first time, the value will be calculated. If the property is never
  accessed in the session, the work will be saved.
  
  This is a very simple program for illustration.
  See subdirectories for more variants, usually starting with start.p.
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.

CLASS 04_lazy_loading.Invoice:

  DEFINE PUBLIC PROPERTY iInvoiceNum AS INTEGER NO-UNDO PUBLIC GET. PRIVATE SET.
  DEFINE PUBLIC PROPERTY iCustNum    AS INTEGER NO-UNDO PUBLIC GET. PRIVATE SET.

  // Find the invoice record and "cache" the key data to properties
  CONSTRUCTOR PUBLIC Invoice(iInvoiceNum AS INTEGER):
    DEFINE BUFFER bInvoice FOR Invoice.

    FIND FIRST bInvoice WHERE bInvoice.Invoicenum = iInvoiceNum NO-LOCK NO-ERROR.
    IF AVAILABLE bInvoice THEN DO:
      THIS-OBJECT:iInvoiceNum = iInvoiceNum.
      THIS-OBJECT:iCustNum    = bInvoice.CustNum.
    END.
  END CONSTRUCTOR.


  DEFINE PUBLIC PROPERTY iInvoiceSum AS INTEGER NO-UNDO INITIAL ?
    PUBLIC GET:
      IF iInvoiceSum = ? THEN DO:
        DEFINE VARIABLE iCN AS INTEGER NO-UNDO.
        iCN = THIS-OBJECT:iCustNum.
        //loop through invoices of customer
        // FOR EACH invoices... WHERE invoices.CustNum = iCustNum...
        //accumulate invoices
      END.
      RETURN iInvoiceSum.
    END GET.
    PRIVATE SET.

END CLASS.
