
 /*------------------------------------------------------------------------
    File        : 04_lazy_loading/lazy_initialization/Invoice
    Purpose     : Example for the Lazy Loading Design Pattern
    Author(s)   : michael.barfs
    Created     : Fri Mar 02 16:14:08 CET 2018
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.

CLASS 04_lazy_loading.lazy_initialization.CustomerOfInvoice:

/*---------------------------------Definitions----------------------------------*/

  DEFINE PUBLIC PROPERTY cCustomerName AS CHARACTER NO-UNDO INITIAL ?
    PUBLIC GET:
      IF cCustomerName = ? THEN DO:
        DEFINE VARIABLE iCN AS INTEGER NO-UNDO.
        iCN = THIS-OBJECT:iCustomerNum.
        DEFINE BUFFER bCustomer FOR Customer.
        FIND FIRST bCustomer WHERE bCustomer.CustNum = iCN NO-LOCK NO-ERROR.
        IF AVAILABLE bCustomer THEN DO:
          cCustomerName = bCustomer.Name.
        END.
      END.
      RETURN cCustomerName.
    END GET.
    PRIVATE SET.

  DEFINE PUBLIC PROPERTY iCustomerNum AS INTEGER NO-UNDO
    PUBLIC GET.
    PRIVATE SET.

  DEFINE PUBLIC PROPERTY iInvoiceNum AS INTEGER NO-UNDO
    PUBLIC GET.
    PRIVATE SET.

/*-------------------------------- Constructor----------------------------------*/

  CONSTRUCTOR PUBLIC CustomerOfInvoice(iInvoiceNum AS INTEGER):

    DEFINE BUFFER bInvoice FOR Invoice.

    FIND FIRST bInvoice WHERE bInvoice.Invoicenum = iInvoiceNum NO-LOCK NO-ERROR.
    IF AVAILABLE bInvoice THEN DO:
      THIS-OBJECT:iInvoiceNum = iInvoiceNum.
      THIS-OBJECT:iCustomerNum = bInvoice.CustNum.
    END.

  END CONSTRUCTOR.

/*----------------------------------End Class-----------------------------------*/

END CLASS.