 /*------------------------------------------------------------------------
    File        : MyServiceProxy
    Author(s)   : michael.barfs, Klaus Erichsen

  This class is a proxy for service.cls. When data will be accessed,
  the proxy will aks the real service for the real data.
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 04_lazy_loading.virtual_proxy.IMyService.
USING 04_lazy_loading.virtual_proxy.MyService.

CLASS 04_lazy_loading.virtual_proxy.MyServiceProxy IMPLEMENTS IMyService:

  DEFINE PRIVATE PROPERTY service AS IMyService NO-UNDO GET. SET.

  METHOD PUBLIC INTEGER GetData():
    InitializeServiceIfNecessary().
    RETURN service:GetData().
  END METHOD.

  METHOD PUBLIC CHARACTER GetMoreData():
    InitializeServiceIfNecessary().
    RETURN service:GetMoreData().
  END METHOD.

  METHOD PRIVATE VOID InitializeServiceIfNecessary():
    IF service = ? THEN
      service = NEW MyService().
  END METHOD.

END CLASS.