
 /*------------------------------------------------------------------------
    File        : 05_adapter/GeoApi
    Purpose     : Handles coordinates, addresses and timezone information.
    Description : Useful functions for geo location
    Author(s)   : klaus.erichsen
    Created     : Wed Jan 09 16:10:25 CET 2019
  ----------------------------------------------------------------------*/

USING 05_adapter.OpenStreetMapsAdapter.
USING 05_adapter.GoogleMapsAdapter.
USING 05_adapter.IMaps.
USING Progress.Lang.*.

CLASS 05_adapter.GeoApi:

  DEFINE PRIVATE PROPERTY oMapApi AS IMaps NO-UNDO PRIVATE GET. PRIVATE SET.


  CONSTRUCTOR PUBLIC GeoApi (INPUT cSearchTool AS CHARACTER):

    CASE cSearchTool:
      WHEN "OSM" THEN DO:
        oMapApi = NEW OpenStreetMapsAdapter().
      END.
      WHEN "Google" THEN DO:
        oMapApi = NEW GoogleMapsAdapter().
      END.
      OTHERWISE DO:
        MESSAGE "Unknown map type: " cSearchTool VIEW-AS ALERT-BOX ERROR.
        RETURN ERROR.
      END.
    END.

  END CONSTRUCTOR.

  METHOD PUBLIC CHARACTER mGetAdrFromCoord (dLat AS DECIMAL, dLng AS DECIMAL):
    RETURN oMapApi:GetAddress(dLat, dLng).
  END METHOD.

END CLASS.