
 /*------------------------------------------------------------------------
    File        : 05_adapter/OpenStreetMapsAdapter
    Author(s)   : klaus.erichsen

  This class calls an OpenStreetMaps service. The way an address is decoded 
  here with OpenStreetMap is different then with Google (although this is
  not reflected in the program).
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING 05_adapter.OpenStreetMapLocation.

USING 05_adapter.IMaps.

BLOCK-LEVEL ON ERROR UNDO, THROW.

CLASS 05_adapter.OpenStreetMapsAdapter IMPLEMENTS IMaps:

  CONSTRUCTOR PUBLIC OpenStreetMapsAdapter (  ):
    /*  Create session connect to Google Maps. */
  END CONSTRUCTOR.


  METHOD PUBLIC CHARACTER GetAddress( INPUT dLat AS DECIMAL, INPUT dLng AS DECIMAL ):

    /*  Call a method in OpenStreetMaps...
        This method is returning a location object, not an string.
        This is simulated here with the creation of a location object. */
    DEFINE VARIABLE o_Location AS 05_adapter.OpenStreetMapLocation NO-UNDO.
    o_Location = NEW 05_adapter.OpenStreetMapLocation ().
    
    RETURN "This address is found by OpenStreetMaps: '" 
      + o_Location:cStreetName + " " + o_Location:cStreetNum + ", "
      + o_Location:cCityZip    + " " + o_Location:cCityName  + "'".
  END METHOD.

END CLASS.